Hex Artifact Content

Artifact f2a658ae1012a6c9d4c3a6477537a6631bbebab3:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 54  2...exit 1.fi..T
00f0: 43 4c 56 46 53 56 45 52 53 3d 22 32 30 30 38 30  CLVFSVERS="20080
0100: 35 30 33 22 0a 53 52 43 3d 22 73 72 63 2f 74 63  503".SRC="src/tc
0110: 6c 76 66 73 2d 24 7b 54 43 4c 56 46 53 56 45 52  lvfs-${TCLVFSVER
0120: 53 7d 2e 74 61 72 2e 67 7a 22 0a 53 52 43 55 52  S}.tar.gz".SRCUR
0130: 4c 3d 22 68 74 74 70 3a 2f 2f 73 6f 75 72 63 65  L="http://source
0140: 66 6f 72 67 65 2e 6e 65 74 2f 70 72 6f 6a 65 63  forge.net/projec
0150: 74 73 2f 74 63 6c 76 66 73 2f 66 69 6c 65 73 2f  ts/tclvfs/files/
0160: 74 63 6c 76 66 73 2f 74 63 6c 76 66 73 2d 24 7b  tclvfs/tclvfs-${
0170: 54 43 4c 56 46 53 56 45 52 53 7d 2f 74 63 6c 76  TCLVFSVERS}/tclv
0180: 66 73 2d 24 7b 54 43 4c 56 46 53 56 45 52 53 7d  fs-${TCLVFSVERS}
0190: 2e 74 61 72 2e 67 7a 2f 64 6f 77 6e 6c 6f 61 64  .tar.gz/download
01a0: 22 0a 42 55 49 4c 44 44 49 52 3d 22 24 28 70 77  ".BUILDDIR="$(pw
01b0: 64 29 2f 62 75 69 6c 64 2f 74 63 6c 76 66 73 2d  d)/build/tclvfs-
01c0: 24 7b 54 43 4c 56 46 53 56 45 52 53 7d 22 0a 4f  ${TCLVFSVERS}".O
01d0: 55 54 44 49 52 3d 22 24 28 70 77 64 29 2f 6f 75  UTDIR="$(pwd)/ou
01e0: 74 22 0a 49 4e 53 54 44 49 52 3d 22 24 28 70 77  t".INSTDIR="$(pw
01f0: 64 29 2f 69 6e 73 74 22 0a 50 41 54 43 48 44 49  d)/inst".PATCHDI
0200: 52 3d 22 24 28 70 77 64 29 2f 70 61 74 63 68 65  R="$(pwd)/patche
0210: 73 22 0a 65 78 70 6f 72 74 20 54 43 4c 56 46 53  s".export TCLVFS
0220: 56 45 52 53 20 53 52 43 20 53 52 43 55 52 4c 20  VERS SRC SRCURL 
0230: 42 55 49 4c 44 44 49 52 20 4f 55 54 44 49 52 20  BUILDDIR OUTDIR 
0240: 49 4e 53 54 44 49 52 20 50 41 54 43 48 44 49 52  INSTDIR PATCHDIR
0250: 0a 0a 72 6d 20 2d 72 66 20 27 62 75 69 6c 64 27  ..rm -rf 'build'
0260: 20 27 6f 75 74 27 20 27 69 6e 73 74 27 0a 6d 6b   'out' 'inst'.mk
0270: 64 69 72 20 27 62 75 69 6c 64 27 20 27 6f 75 74  dir 'build' 'out
0280: 27 20 27 69 6e 73 74 27 20 7c 7c 20 65 78 69 74  ' 'inst' || exit
0290: 20 31 0a 0a 54 43 4c 5f 56 45 52 53 49 4f 4e 3d   1..TCL_VERSION=
02a0: 22 75 6e 6b 6e 6f 77 6e 22 0a 69 66 20 5b 20 2d  "unknown".if [ -
02b0: 66 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49  f "${TCLCONFIGDI
02c0: 52 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68 22  R}/tclConfig.sh"
02d0: 20 5d 3b 20 74 68 65 6e 0a 09 73 6f 75 72 63 65   ]; then..source
02e0: 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52   "${TCLCONFIGDIR
02f0: 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68 22 0a  }/tclConfig.sh".
0300: 66 69 0a 65 78 70 6f 72 74 20 54 43 4c 5f 56 45  fi.export TCL_VE
0310: 52 53 49 4f 4e 0a 0a 69 66 20 5b 20 21 20 2d 66  RSION..if [ ! -f
0320: 20 22 24 7b 53 52 43 7d 22 20 5d 3b 20 74 68 65   "${SRC}" ]; the
0330: 6e 0a 09 6d 6b 64 69 72 20 27 73 72 63 27 20 3e  n..mkdir 'src' >
0340: 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76  /dev/null 2>/dev
0350: 2f 6e 75 6c 6c 0a 0a 09 69 66 20 5b 20 21 20 2d  /null...if [ ! -
0360: 64 20 27 62 75 69 6c 64 73 72 63 27 20 5d 3b 20  d 'buildsrc' ]; 
0370: 74 68 65 6e 0a 09 09 72 6d 20 2d 66 20 22 24 7b  then...rm -f "${
0380: 53 52 43 7d 2e 74 6d 70 22 0a 09 09 77 67 65 74  SRC}.tmp"...wget
0390: 20 2d 4f 20 22 24 7b 53 52 43 7d 2e 74 6d 70 22   -O "${SRC}.tmp"
03a0: 20 22 24 7b 53 52 43 55 52 4c 7d 22 20 7c 7c 20   "${SRCURL}" || 
03b0: 65 78 69 74 20 31 0a 09 09 6d 76 20 22 24 7b 53  exit 1...mv "${S
03c0: 52 43 7d 2e 74 6d 70 22 20 22 24 7b 53 52 43 7d  RC}.tmp" "${SRC}
03d0: 22 0a 09 66 69 0a 66 69 0a 0a 28 0a 09 63 64 20  "..fi.fi..(..cd 
03e0: 27 62 75 69 6c 64 27 20 7c 7c 20 65 78 69 74 20  'build' || exit 
03f0: 31 0a 0a 09 69 66 20 5b 20 21 20 2d 64 20 27 2e  1...if [ ! -d '.
0400: 2e 2f 62 75 69 6c 64 73 72 63 27 20 5d 3b 20 74  ./buildsrc' ]; t
0410: 68 65 6e 0a 09 09 67 7a 69 70 20 2d 64 63 20 22  hen...gzip -dc "
0420: 2e 2e 2f 24 7b 53 52 43 7d 22 20 7c 20 74 61 72  ../${SRC}" | tar
0430: 20 2d 78 66 20 2d 0a 09 65 6c 73 65 20 20 20 20   -xf -..else    
0440: 0a 09 09 63 70 20 2d 72 70 20 2e 2e 2f 62 75 69  ...cp -rp ../bui
0450: 6c 64 73 72 63 2f 2a 20 27 2e 2f 27 0a 09 66 69  ldsrc/* './'..fi
0460: 0a 0a 09 63 64 20 22 24 7b 42 55 49 4c 44 44 49  ...cd "${BUILDDI
0470: 52 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 20  R}" || exit 1.. 
0480: 20 20 20 20 20 20 20 23 20 41 70 70 6c 79 20 72         # Apply r
0490: 65 71 75 69 72 65 64 20 70 61 74 63 68 65 73 0a  equired patches.
04a0: 09 66 6f 72 20 70 61 74 63 68 20 69 6e 20 22 24  .for patch in "$
04b0: 7b 50 41 54 43 48 44 49 52 7d 2f 61 6c 6c 22 2f  {PATCHDIR}/all"/
04c0: 74 63 6c 76 66 73 2d 24 7b 54 43 4c 56 46 53 56  tclvfs-${TCLVFSV
04d0: 45 52 53 7d 2d 2a 2e 64 69 66 66 20 22 24 7b 50  ERS}-*.diff "${P
04e0: 41 54 43 48 44 49 52 7d 2f 24 7b 54 43 4c 5f 56  ATCHDIR}/${TCL_V
04f0: 45 52 53 49 4f 4e 7d 22 2f 74 63 6c 76 66 73 2d  ERSION}"/tclvfs-
0500: 24 7b 54 43 4c 56 46 53 56 45 52 53 7d 2d 2a 2e  ${TCLVFSVERS}-*.
0510: 64 69 66 66 3b 20 64 6f 0a 09 09 69 66 20 5b 20  diff; do...if [ 
0520: 21 20 2d 66 20 22 24 7b 70 61 74 63 68 7d 22 20  ! -f "${patch}" 
0530: 5d 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e 74 69  ]; then....conti
0540: 6e 75 65 0a 09 09 66 69 0a 0a 09 09 65 63 68 6f  nue...fi....echo
0550: 20 22 41 70 70 6c 79 69 6e 67 3a 20 24 7b 70 61   "Applying: ${pa
0560: 74 63 68 7d 22 0a 09 09 24 7b 50 41 54 43 48 3a  tch}"...${PATCH:
0570: 2d 70 61 74 63 68 7d 20 2d 70 31 20 3c 20 22 24  -patch} -p1 < "$
0580: 7b 70 61 74 63 68 7d 22 0a 09 64 6f 6e 65 20 20  {patch}"..done  
0590: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
05a0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
05b0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
05c0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
05d0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
05e0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
05f0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
0600: 20 20 20 20 20 20 20 20 20 20 20 20 20 0a 0a 09               ...
0610: 63 70 20 67 65 6e 65 72 69 63 2f 76 66 73 2e 63  cp generic/vfs.c
0620: 20 2e 0a 0a 09 23 20 49 66 20 77 65 20 61 72 65   ....# If we are
0630: 20 62 75 69 6c 64 69 6e 67 20 66 6f 72 20 57 69   building for Wi
0640: 6e 33 32 2c 20 77 65 20 6e 65 65 64 20 74 6f 20  n32, we need to 
0650: 64 65 66 69 6e 65 20 54 45 41 5f 50 4c 41 54 46  define TEA_PLATF
0660: 4f 52 4d 20 73 6f 20 74 68 61 74 0a 09 23 20 74  ORM so that..# t
0670: 68 65 20 72 69 67 68 74 20 70 72 69 76 61 74 65  he right private
0680: 20 64 69 72 65 63 74 6f 72 79 20 69 73 20 66 6f   directory is fo
0690: 75 6e 64 0a 09 42 55 49 4c 44 54 59 50 45 3d 22  und..BUILDTYPE="
06a0: 24 28 62 61 73 65 6e 61 6d 65 20 22 24 7b 54 43  $(basename "${TC
06b0: 4c 43 4f 4e 46 49 47 44 49 52 7d 22 29 22 0a 09  LCONFIGDIR}")"..
06c0: 69 66 20 5b 20 22 24 7b 42 55 49 4c 44 54 59 50  if [ "${BUILDTYP
06d0: 45 7d 22 20 3d 20 22 77 69 6e 22 20 5d 3b 20 74  E}" = "win" ]; t
06e0: 68 65 6e 0a 09 09 54 45 41 5f 50 4c 41 54 46 4f  hen...TEA_PLATFO
06f0: 52 4d 3d 22 77 69 6e 64 6f 77 73 22 0a 09 09 65  RM="windows"...e
0700: 78 70 6f 72 74 20 54 45 41 5f 50 4c 41 54 46 4f  xport TEA_PLATFO
0710: 52 4d 0a 0a 09 09 43 46 4c 41 47 53 3d 22 24 7b  RM....CFLAGS="${
0720: 43 46 4c 41 47 53 7d 20 2d 49 24 7b 54 43 4c 43  CFLAGS} -I${TCLC
0730: 4f 4e 46 49 47 44 49 52 7d 22 0a 09 09 65 78 70  ONFIGDIR}"...exp
0740: 6f 72 74 20 43 46 4c 41 47 53 0a 09 66 69 0a 0a  ort CFLAGS..fi..
0750: 09 23 20 49 66 20 77 65 20 61 72 65 20 62 75 69  .# If we are bui
0760: 6c 64 69 6e 67 20 66 6f 72 20 4b 69 74 44 4c 4c  lding for KitDLL
0770: 2c 20 63 6f 6d 70 69 6c 65 20 77 69 74 68 20 27  , compile with '
0780: 2d 66 50 49 43 27 0a 09 69 66 20 5b 20 22 24 7b  -fPIC'..if [ "${
0790: 4b 49 54 54 41 52 47 45 54 7d 22 20 3d 20 22 6b  KITTARGET}" = "k
07a0: 69 74 64 6c 6c 22 20 5d 3b 20 74 68 65 6e 0a 09  itdll" ]; then..
07b0: 09 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47  .CFLAGS="${CFLAG
07c0: 53 7d 20 2d 66 50 49 43 22 0a 09 09 65 78 70 6f  S} -fPIC"...expo
07d0: 72 74 20 43 46 4c 41 47 53 0a 09 66 69 0a 0a 09  rt CFLAGS..fi...
07e0: 23 20 42 75 69 6c 64 20 73 74 61 74 69 63 20 76  # Build static v
07f0: 65 72 73 69 6f 6e 0a 09 65 63 68 6f 20 22 52 75  ersion..echo "Ru
0800: 6e 6e 69 6e 67 3a 20 2e 2f 63 6f 6e 66 69 67 75  nning: ./configu
0810: 72 65 20 2d 2d 64 69 73 61 62 6c 65 2d 73 68 61  re --disable-sha
0820: 72 65 64 20 2d 2d 70 72 65 66 69 78 3d 5c 22 24  red --prefix=\"$
0830: 7b 49 4e 53 54 44 49 52 7d 5c 22 20 2d 2d 65 78  {INSTDIR}\" --ex
0840: 65 63 2d 70 72 65 66 69 78 3d 5c 22 24 7b 49 4e  ec-prefix=\"${IN
0850: 53 54 44 49 52 7d 5c 22 20 2d 2d 6c 69 62 64 69  STDIR}\" --libdi
0860: 72 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c  r=\"${INSTDIR}/l
0870: 69 62 5c 22 20 2d 2d 77 69 74 68 2d 74 63 6c 3d  ib\" --with-tcl=
0880: 5c 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52  \"${TCLCONFIGDIR
0890: 7d 5c 22 20 24 7b 43 4f 4e 46 49 47 55 52 45 45  }\" ${CONFIGUREE
08a0: 58 54 52 41 7d 22 0a 09 2e 2f 63 6f 6e 66 69 67  XTRA}".../config
08b0: 75 72 65 20 2d 2d 64 69 73 61 62 6c 65 2d 73 68  ure --disable-sh
08c0: 61 72 65 64 20 2d 2d 70 72 65 66 69 78 3d 22 24  ared --prefix="$
08d0: 7b 49 4e 53 54 44 49 52 7d 22 20 2d 2d 65 78 65  {INSTDIR}" --exe
08e0: 63 2d 70 72 65 66 69 78 3d 22 24 7b 49 4e 53 54  c-prefix="${INST
08f0: 44 49 52 7d 22 20 2d 2d 6c 69 62 64 69 72 3d 22  DIR}" --libdir="
0900: 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 22 20  ${INSTDIR}/lib" 
0910: 2d 2d 77 69 74 68 2d 74 63 6c 3d 22 24 7b 54 43  --with-tcl="${TC
0920: 4c 43 4f 4e 46 49 47 44 49 52 7d 22 20 24 7b 43  LCONFIGDIR}" ${C
0930: 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 0a 0a  ONFIGUREEXTRA}..
0940: 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20  .echo "Running: 
0950: 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 22 0a 09  ${MAKE:-make}"..
0960: 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 7c 7c  ${MAKE:-make} ||
0970: 20 65 78 69 74 20 31 0a 0a 09 65 63 68 6f 20 22   exit 1...echo "
0980: 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a  Running: ${MAKE:
0990: 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c 6c 22 0a  -make} install".
09a0: 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 69  .${MAKE:-make} i
09b0: 6e 73 74 61 6c 6c 20 7c 7c 20 65 78 69 74 20 31  nstall || exit 1
09c0: 0a 0a 09 6d 6b 64 69 72 20 22 24 7b 4f 55 54 44  ...mkdir "${OUTD
09d0: 49 52 7d 2f 6c 69 62 22 20 7c 7c 20 65 78 69 74  IR}/lib" || exit
09e0: 20 31 0a 09 63 70 20 2d 72 20 22 24 7b 49 4e 53   1..cp -r "${INS
09f0: 54 44 49 52 7d 2f 6c 69 62 22 2f 76 66 73 2a 20  TDIR}/lib"/vfs* 
0a00: 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62 2f 22  "${OUTDIR}/lib/"
0a10: 0a 09 72 6d 20 2d 66 20 22 24 7b 4f 55 54 44 49  ..rm -f "${OUTDI
0a20: 52 7d 2f 6c 69 62 22 2f 76 66 73 2a 2f 2a 2e 61  R}/lib"/vfs*/*.a
0a30: 20 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62 22   "${OUTDIR}/lib"
0a40: 2f 76 66 73 2a 2f 2a 2e 73 6f 0a 0a 09 65 78 69  /vfs*/*.so...exi
0a50: 74 20 30 0a 29 20 7c 7c 20 65 78 69 74 20 31 0a  t 0.) || exit 1.
0a60: 0a 65 78 69 74 20 30 0a                          .exit 0.